=== debian/changelog ===
opam (2.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 07 Jan 2025 11:21:36 +0100
