## opam 2.4.1

=== Makefile ===
--- 
+++ 
@@ -71,6 +71,11 @@
 	@cd Opam.Runtime.$(MANIFEST_ARCH) && $(LN_S) -f ../_build/install/default/bin/Opam.Runtime.$(MANIFEST_ARCH)/$(RUNTIME_GCC_S).dll .
 endif
 
+opam-stripped: $(DUNE_DEP) build-opam processed-opam.install
+	@cp -f _build/default/src/client/opamMain.exe "$@$(EXE)"
+	@chmod 755 "$@$(EXE)"
+	strip "$@$(EXE)"
+
 opam-installer: $(DUNE_DEP) build-opam-installer processed-opam-installer.install
 	@$(LN_S) -f _build/default/src/tools/opam_installer.exe $@$(EXE)
 
@@ -96,7 +101,9 @@
 distclean: clean clean-ext
 	rm -rf autom4te.cache bootstrap
 	rm -f Makefile.config config.log config.status aclocal.m4
-	rm -f src/*.META src/*/.merlin src/manifest/dune src/manifest/install.inc src/stubs/win32/dune src/core/cc64 src/ocaml-flags-configure.sexp
+	rm -f src/*.META src/*/.merlin src/manifest/dune src/manifest/install.inc \
+        src/stubs/win32/dune src/core/cc64 src/ocaml-flags-configure.sexp \
+        src/state/opamEmbeddedCygwinSetup.ml
 	rm -f src/client/linking.sexp src/core/c-flags.sexp src/core/developer src/core/version
 
 OPAMINSTALLER_FLAGS = --prefix "$(call CYGPATH,$(DESTDIR)$(prefix))"
