=== release/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 OCAML_URL = https://github.com/ocaml/ocaml/archive/refs/tags/$(OCAMLV).tar.gz
 FLEXDLL_URL = https://github.com/ocaml/flexdll/archive/refs/tags/$(FLEXDLLV).tar.gz
 
-ALPINE_VERSION = 3.20
+ALPINE_VERSION = 3.21
 
 HOST_OS = $(shell uname -s | tr A-Z a-z | sed -e 's/_.*//' -e 's/darwin/macos/' -e 's/cygwin/windows/')
 HOST = $(shell uname -m | sed 's/amd64/x86_64/')-$(HOST_OS)
@@ -92,6 +92,7 @@
 LIBRARY_PATH=/usr/local/lib: \
 
 EXTRA_CONFIGURE_ARGS_windows = --host=x86_64-w64-mingw32 --with-flexdll
+EXTRA_OPAM_CONFIGURE_ARGS_windows = --with-cygwin-setup
 
 %: opam-$(VERSION)-%
 
@@ -128,13 +129,12 @@
 	    MAKE=$(MAKE) \
 	    $(EXPORTS_$(HOST_OS)); \
 	  cd build/opam-full-$(VERSION) && \
-	  ./configure --with-vendored-deps --with-mccs && \
+	  ./configure --with-vendored-deps --with-mccs \
+	    $(EXTRA_OPAM_CONFIGURE_ARGS_$(HOST_OS)) && \
 	  echo "$(call LINKING,$(HOST_OS))" >src/client/linking.sexp && \
-	  $(MAKE) opam; \
+	  $(MAKE) opam-stripped; \
 	)
-	chmod u+w build/opam-full-$(VERSION)/_build/default/src/client/opamMain.exe
-	cp build/opam-full-$(VERSION)/opam $(OUTDIR)/opam-$(VERSION)-$(HOST)
-	strip $(OUTDIR)/opam-$(VERSION)-$(HOST)
+	cp build/opam-full-$(VERSION)/opam-stripped $(OUTDIR)/opam-$(VERSION)-$(HOST)
 	$(OUTDIR)/opam-$(VERSION)-$(HOST) --version
 	rm -rf build/opam-full-$(VERSION)
