=== debian/changelog ===
opam (2.4.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Aug 2025 20:26:36 +0200
