=== debian/control ===
--- 
+++ 
@@ -25,6 +25,7 @@
  libopam-0install-cudf-ocaml-dev,
  libspdx-licenses-ocaml-dev,
  libswhid-core-ocaml-dev,
+ libpatch-ocaml-dev,
  curl
 Build-Depends-Indep:
  texlive-latex-base <!nodoc>,
