=== debian/tests/control ===
Tests: 4.14.1 ocaml-system
Depends: @, ca-certificates, ocaml
Restrictions: allow-stderr, needs-internet
