=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((rc|beta|alpha)[\d.]*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/opam-$1\.tar\.gz/ \
  https://github.com/ocaml/opam/tags .*/v?([0-9.]+)\.tar\.gz
