=== debian/changelog ===
opam (2.5.0-1) unstable; urgency=medium

  * New upstream release
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Tue, 02 Dec 2025 15:39:14 +0100
