=== debian/control ===
--- 
+++ 
@@ -35,8 +35,7 @@
  texlive-fonts-recommended <!nodoc>,
  man2html-base <!nodoc>,
  latex-make <!nodoc>
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://opam.ocaml.org
 Vcs-Git: https://salsa.debian.org/ocaml-team/opam.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/opam
