=== debian/watch ===
Version: 5

Source: https://github.com/ocaml/opam/tags
Matching-Pattern: .*/v?([0-9.]+)\.tar\.gz
Filenamemangle: s/.+\/v?(\d\S+)\.tar\.gz/opam-$1\.tar\.gz/
Uversionmangle: s/(\d)[_\.\-\+]?((rc|beta|alpha)[\d.]*)$/$1~$2/
